#!/usr/bin/env python
#
##
##	BackAndPrepare.py:   		Stacking of individual datasets
##
##	Inputs: 		List of files generated by the identification
##	Outputs:		rnIMAGENAME
##
##	Version 1.0: 		22/02/2011
##

#
# Import libraries
#


import sys
from pyraf import *
import astropy.io.fits
import numpy
from astropy.io.fits import getdata, getheader
#iraf.reset(gemini="extern$gemini_public_1_11_1/")
iraf.gemini(_doprint=0, motd="no")
iraf.gnirs(_doprint=0)
iraf.imutil(_doprint=0)
iraf.nsheaders('gnirs',Stdout='/dev/null')

flinter = sys.argv[3:4][0]
configdir = sys.argv[4:5][0]

def getFileNames(start, end):
    infile = sys.argv[start:end][0]
    flatfile = open(infile,'r')
    j = 1
    listA = ''
    for line in flatfile.readlines():
        filename = str(line.replace('.fits',''))
        filename = filename.replace('\n','')
        if j == 1:			
            listA += 'rnc'+filename
        else:
            listA += ',rnc'+filename
        j = int(j) +1
    return infile.replace('.lst',''), listA
    
def makeFlat(flatlist, name, thr_fup, order, scale, nums):
    #For reasons nobody understands, sometimes nsflat crashes with a fixpix or other mysterious error
    #Seem to be able to get round it by fiddling with the lthresh parameter
    #So, if necessary, run nsflat with a few different values of lthresh until it (hopefully) works
    for i in nums:
        try:
            iraf.nsflat(lampson=flatlist,darks='',flatfile=name+'.fits',darkfile='',fl_corner='yes',fl_save_dark='no',flattitle='default',bpmtitle='default',bpmfile='default',process="fit",statsec='MDF',fitsec='MDF',thr_flo=0.35,thr_fup=thr_fup,thr_dlo=-20,thr_dup=100,fl_inter=flinter,fl_range='no',fl_fixbad='yes',fixvalue=1,function='spline3',order=order,normstat='midpt',combtype='default',rejtype='ccdclip',masktype='goodvalue',maskvalue=0.0,scale=scale,zero='none',weight='none',lthreshold=float(i),hthreshold='INDEF',nlow=1,nhigh=1,nkeep=0,mclip='yes',lsigma=3.0,hsigma=3.0,snoise='0.0',sigscale=0.1,pclip=-0.5,grow=0.0,box_width=20,box_length=1,trace='',traceproc='none',threshold=100.0,aptable=configdir+'config/apertures.fits',database='',apsum=10,tr_step=10,tr_nlost=3,tr_function='legendre',tr_order=5,tr_naver=1,tr_niter=0,tr_lowrej=3.0,tr_highrej=3.0,tr_grow=0.0,ap_lower=-30,ap_upper=30,fl_vardq='yes',logfile='',verbose='yes',mode='al')
            break
        except (TypeError,iraf.IrafError) as e:
            if i != 10:
                print( "**NSFLAT ERROR: "+str(e))
                print( "**XDGNIRS: nsflat crashed; trying again with new value of lthresh")
                print( "")
                iraf.imdelete(name+'.fits',verify='no')
                iraf.imdelete(name+'_bpm.pl',verify='no')
                continue
            else:
                print( e)
                print( "XDGNIRS: nsflat crashed; already tried 3 values of lthresh; don't know what to do now; exiting script")
                sys.exit()

#Combine and normalise the IR flats
IRname, IRlist = getFileNames(1,2)
makeFlat(IRlist, IRname, thr_fup=1.5, order=10, scale='none', nums=[30,50,10,5])                

#Combine and normalise the QH flats
QHname, QHlist = getFileNames(2,3)
makeFlat(QHlist, QHname, thr_fup=4, order=5, scale='median', nums=[50,30,10,5])     

#Combine order 3 of the IR flat and orders 4-8 of the QH flats into the master flat
try:
    iraf.fxcopy(input=IRname+'.fits',output='MasterFlat.fits',group="0-3",new_file='yes',verbose='no',mode='ql')
    iraf.fxinsert(input=QHname+'.fits',output='MasterFlat.fits[3]',groups="4-18",verbose='no',mode='ql')
#except(TypeError, iraf.IrafError, e):
except (TypeError,iraf.IrafError) as e:
    print( "**NSFLAT ERROR: "+str(e))

